// Deklaracija spremenljivk
// Spremenljivke je možno uporabiti v vseh funkcijah v tej datoteki

var n;                // število točk prereza
var x = new Array()   // X koordinate točk
var y = new Array()   // Y koordinate točk
var A;                // Ploščina prereza
var Sx, Sy;
var Ix, Iy, Ixy;
var xt, yt;
var Ixt, Iyt, Ixyt;

window.onload = function() {
  // fileInput je input#file polje za izbiranje lokalne datoteke
	var fileInput = document.getElementById('fileInput');
  
  // fileInputArea je id elementa v HTML, ki označuje mesto, kjer naj se izpišejo podatki 
	var fileInputArea = document.getElementById('fileInputArea');

  // Na fileInput element dodamo funkcijo, ki se sproži, ko se element spremeni
	fileInput.addEventListener('change', function(e) {
		var file = fileInput.files[0];
		var textType = /text.*/;

		if (file.type.match(textType)) {
			var reader = new FileReader();
      
      // funkcija se sproži, ko se datoteka v celoti prebere
      reader.onload = function(e) {
        Podatki(reader.result);
        Izracun();
        Izpis();
      }
      reader.readAsText(file);
    } else {
			fileInputArea.innerText = "File not supported!";
		}
	});
}

function Podatki(data) {
  // Niz znakov celotne datoteke razdelimo na vrstice
  var lines = data.split("\n");
  
  // V prvi vrstici mora biti zapisano število točk prereza
  n = parseInt(lines[0]);
  
  // Kontrolni izpis v konzolno okno brskalnika
  console.log("n = " + n);
  console.log("lines = " + lines.length);
  
  // Zanka preko vseh točk
  for(var i = 1; i <= n; i++) {
    // Vrstivo razdelimo na posamezne besede
    var besede = lines[i].split(" ");
    
    // Prva besede je X koordinata točke, druga pa Y koordinata točke
    x[i] = parseFloat(besede[0]);
    y[i] = parseFloat(besede[1]);
    
    // Kontrolni izpis v konzolno okno brskalnika
    console.log("x = " + x[i] + "; y = " + y[i]);
  }
  // Določimo še n+1 točko, ki je enaka 1 točki prereza
  x[n+1] = x[1];
  y[n+1] = y[1];
  
  var str = "";
  str = str + "Število točk: " + n + "<br />"
  
  str = str + "<table class=\"table\">";
  str = str + "<tr><th>i</th><th>x</th><th>y</th></tr>";
  for(var i = 1; i <= n; i++) {
    str = str + "<tr>";
    str = str + "<td>" + i + "</td>";
    str = str + "<td>" + x[i] + "</td>";
    str = str + "<td>" + y[i] + "</td>";
    str = str + "</tr>";
  }
  str = str + "</table>";
 
 document.getElementById('fileInputArea').innerHTML = str; 
}

function Izracun() {
  // Izračun izkanih vrednosti
  A = 0;
  for(var i = 1; i <= n; i++) {
    A = A + (x[i+1] + x[i]) * (y[i+1]- y[i]);
  }
  A = 0.5 * A;
  
  Sx = 0;
  for(var i = 1; i <= n; i++) {
    Sx = Sx + (x[i+1] - x[i]) * (Math.pow(y[i+1], 2) + y[i] * y[i+1] + Math.pow(y[i],2));
  }
  Sx = -Sx / 6;

  Sy = 0;
  for(var i = 1; i <= n; i++) {
    Sy = Sy + (y[i+1] - y[i]) * (Math.pow(x[i+1],2) + x[i] * y[i+1] + Math.pow(x[i],2));
  }
  Sy = Sy / 6;
  
  Ix = 0;
  for(var i = 1; i <= n; i++) {
    Ix = Ix + (x[i+1] - x[i]) * (Math.pow(y[i+1],3) + Math.pow(y[i+1],2) * y[i] + y[i+1] * Math.pow(y[i],2) + Math.pow(y[i],3));
  }
  Ix = -Ix / 12;

  Iy = 0;
  for(var i = 1; i <= n; i++) {
    Iy = Iy + (y[i+1] - y[i]) * (Math.pow(x[i+1],3) + Math.pow(x[i+1],2) * x[i] + x[i+1] * Math.pow(x[i],2) + Math.pow(x[i],3));
  }
  Iy = Iy / 12;

  Ixy = 0;
  for(var i = 1; i <= n; i++) {
    Ixy = Ixy + (y[i+1] - y[i]) * (y[i+1] * (3 * Math.pow(x[i+1],2) + 2 * x[i+1] * x[i] + Math.pow(x[i],2)) + y[i] * (3 * Math.pow(x[i],2) + 2 * x[i+1] * x[i] + Math.pow(x[i+1],2)));
  }
  Ixy = Ixy / 12;

  xt = Sy / A;
  yt = Sx / A;
  
  Ixt = Ix - Math.pow(yt,2) * A;
  Iyt = Iy - Math.pow(xt,2) * A;
  Ixyt = Ixy + xt * yt * A;
}

function Izpis () {
  // Izpis rezultatov
  var str = "";
  
  str = str + "<table class=\"table\">";
  str = str + "<tr><td>A</td><td>" + Math.round(1000*A)/1000 +"</td></tr>";
  str = str + "<tr><td>Sx</td><td>" + Math.round(1000*Sx)/1000 +"</td></tr>";
  str = str + "<tr><td>Sy</td><td>" + Math.round(1000*Sy)/1000 +"</td></tr>";
  str = str + "<tr><td>Ix</td><td>" + Math.round(1000*Ix)/1000 +"</td></tr>";
  str = str + "<tr><td>Iy</td><td>" + Math.round(1000*Iy)/1000 +"</td></tr>";
  str = str + "<tr><td>Ixy</td><td>" + Math.round(1000*Ixy)/1000 +"</td></tr>";
  str = str + "<tr><td>xt</td><td>" + Math.round(1000*xt)/1000 +"</td></tr>";
  str = str + "<tr><td>yt</td><td>" + Math.round(1000*yt)/1000 +"</td></tr>";
  str = str + "<tr><td>Ixt</td><td>" + Math.round(1000*Ixt)/1000 +"</td></tr>";
  str = str + "<tr><td>Iyt</td><td>" + Math.round(1000*Iyt)/1000 +"</td></tr>";
  str = str + "<tr><td>Ixyt</td><td>" + Math.round(1000*Ixyt)/1000 +"</td></tr>";
  str = str + "</table>";
  
  // str = str + "A = " + A + "<br />";
  // str = str + "Sx = " + Sy + "<br />";
  // str = str + "Sy = " + Sy + "<br />";
  // str = str + "Ix = " + Ix + "<br />";
  // str = str + "Iy = " + Iy + "<br />";
  // str = str + "Ixy = " + Ixy + "<br />";
  // str = str + "xt = " + xt + "<br />";
  // str = str + "yt = " + yt + "<br />";
  // str = str + "Ixt = " + Ixy + "<br />";
  // str = str + "Iyt = " + Iyt + "<br />";
  // str = str + "Ixyt = " + Ixyt + "<br />";

  document.getElementById("rezultati").innerHTML = str; 
}
